/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ID = 258,
     OP = 259,
     ADD = 260,
     SUBTRACT = 261,
     TIMES = 262,
     DIVIDE = 263,
     MOD = 264,
     EXPONENT = 265,
     DOTS = 266,
     COLONS = 267,
     DASHES = 268,
     LONGDASH = 269,
     INCR = 270,
     CONTROLS = 271,
     TENSION = 272,
     ATLEAST = 273,
     CURL = 274,
     CYCLE = 275,
     COR = 276,
     CAND = 277,
     EQ = 278,
     NEQ = 279,
     LT = 280,
     LE = 281,
     GT = 282,
     GE = 283,
     CARETS = 284,
     LOGNOT = 285,
     STRING = 286,
     LOOSE = 287,
     ASSIGN = 288,
     DIRTAG = 289,
     JOIN_PREC = 290,
     AND = 291,
     ELLIPSIS = 292,
     IMPORT = 293,
     STRUCT = 294,
     TYPEDEF = 295,
     NEW = 296,
     IF = 297,
     ELSE = 298,
     WHILE = 299,
     DO = 300,
     FOR = 301,
     BREAK = 302,
     CONTINUE = 303,
     RETURN_ = 304,
     STATIC = 305,
     PUBLIC_TOK = 306,
     PRIVATE_TOK = 307,
     THIS = 308,
     EXPLICIT = 309,
     LIT = 310,
     PERM = 311,
     MODIFIER = 312,
     UNARY = 313
   };
#endif
#define ID 258
#define OP 259
#define ADD 260
#define SUBTRACT 261
#define TIMES 262
#define DIVIDE 263
#define MOD 264
#define EXPONENT 265
#define DOTS 266
#define COLONS 267
#define DASHES 268
#define LONGDASH 269
#define INCR 270
#define CONTROLS 271
#define TENSION 272
#define ATLEAST 273
#define CURL 274
#define CYCLE 275
#define COR 276
#define CAND 277
#define EQ 278
#define NEQ 279
#define LT 280
#define LE 281
#define GT 282
#define GE 283
#define CARETS 284
#define LOGNOT 285
#define STRING 286
#define LOOSE 287
#define ASSIGN 288
#define DIRTAG 289
#define JOIN_PREC 290
#define AND 291
#define ELLIPSIS 292
#define IMPORT 293
#define STRUCT 294
#define TYPEDEF 295
#define NEW 296
#define IF 297
#define ELSE 298
#define WHILE 299
#define DO 300
#define FOR 301
#define BREAK 302
#define CONTINUE 303
#define RETURN_ 304
#define STATIC 305
#define PUBLIC_TOK 306
#define PRIVATE_TOK 307
#define THIS 308
#define EXPLICIT 309
#define LIT 310
#define PERM 311
#define MODIFIER 312
#define UNARY 313




/* Copy the first part of user declarations.  */
#line 1 "camp.y"

/*****
 * camp.y
 * Andy Hammerlindl 08/12/2002
 *
 * The grammar of the camp language.
 *****/

#include "errormsg.h"
#include "exp.h"
#include "newexp.h"
#include "dec.h"
#include "fundec.h"
#include "stm.h"
#include "modifier.h"

// Avoid error messages with unpatched bison-1.875:
#ifndef __attribute__
#define __attribute__(x)
#endif

// Used when a position needs to be determined and no token is
// available.  Defined in camp.l.
position lexerPos();

int yylex(void); /* function prototype */

void yyerror(const char *s)
{
  em->error(lexerPos());
  *em << s;
  em->sync();
}

namespace absyntax { file *root; }

using namespace absyntax;
using sym::symbol;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 41 "camp.y"
typedef union YYSTYPE {
  position pos;
  //sym::symbol *sym;
  struct {
    position pos;
    sym::symbol *sym;
  } ps;
  absyntax::name *n;
  absyntax::varinit *vi;
  absyntax::arrayinit *ai;
  absyntax::exp *e;
  absyntax::specExp *se;
  absyntax::joinExp *j;
  absyntax::explist *elist;
  absyntax::argument arg;
  absyntax::arglist *alist;
  absyntax::dimensions *dim;
  absyntax::ty  *t;
  absyntax::decid *di;
  absyntax::decidlist *dil;
  absyntax::decidstart *dis;
  absyntax::runnable *run;
  struct {
    position pos;
    trans::permission val;
  } perm;
  struct {
    position pos;
    trans::modifier val;
  } mod;
  absyntax::modifierList *ml;
  //absyntax::program *prog;
  absyntax::vardec *vd;
  //absyntax::vardecs *vds;
  absyntax::dec *d;
  absyntax::stm *s;
  absyntax::blockStm *bs;
  absyntax::stmExpList *sel;
  //absyntax::funheader *fh;
  absyntax::formal *fl;
  absyntax::formals *fls;
  absyntax::file *fil;
} YYSTYPE;
/* Line 190 of yacc.c.  */
#line 276 "camp.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 288 "camp.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1983

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  76
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  42
/* YYNRULES -- Number of rules. */
#define YYNRULES  174
/* YYNRULES -- Number of states. */
#define YYNSTATES  334

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   313

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    34,     2,     2,
      47,    48,    32,    29,    50,    31,    49,    33,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    41,    53,
       2,     2,     2,    39,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    51,     2,    52,    35,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    44,     2,    46,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    30,    36,    37,    38,    40,    42,
      43,    45,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     6,     9,    10,    13,    15,    19,
      23,    25,    27,    30,    33,    35,    37,    40,    43,    45,
      47,    49,    53,    57,    60,    63,    65,    68,    70,    73,
      77,    81,    86,    88,    92,    94,    98,   100,   103,   107,
     112,   114,   116,   120,   123,   128,   132,   138,   140,   142,
     145,   147,   151,   153,   157,   160,   162,   166,   168,   171,
     176,   179,   183,   189,   195,   202,   209,   213,   216,   220,
     225,   230,   234,   239,   243,   248,   252,   254,   256,   260,
     262,   266,   269,   271,   275,   277,   279,   281,   283,   286,
     291,   297,   300,   303,   306,   310,   314,   318,   322,   326,
     330,   334,   338,   342,   346,   350,   354,   358,   362,   366,
     370,   373,   377,   382,   386,   391,   397,   404,   411,   419,
     425,   429,   435,   443,   457,   461,   465,   468,   471,   474,
     477,   481,   485,   489,   493,   497,   501,   503,   505,   508,
     511,   515,   520,   524,   530,   532,   536,   540,   542,   544,
     547,   552,   556,   562,   565,   570,   572,   574,   577,   583,
     591,   597,   605,   615,   618,   621,   624,   628,   630,   631,
     633,   635,   636,   638,   640
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      77,     0,    -1,    78,    -1,    -1,    78,    81,    -1,    -1,
      79,    81,    -1,     3,    -1,    80,    49,     3,    -1,    37,
      49,     3,    -1,    83,    -1,   113,    -1,    82,    83,    -1,
      82,    94,    -1,    74,    -1,    73,    -1,    82,    74,    -1,
      82,    73,    -1,    84,    -1,   101,    -1,   102,    -1,    55,
       3,    53,    -1,    55,    37,    53,    -1,    85,    53,    -1,
      86,    90,    -1,    87,    -1,    80,    88,    -1,    80,    -1,
      51,    52,    -1,    88,    51,    52,    -1,    51,   107,    52,
      -1,    89,    51,   107,    52,    -1,    91,    -1,    90,    50,
      91,    -1,    92,    -1,    92,    40,    93,    -1,     3,    -1,
       3,    88,    -1,     3,    47,    48,    -1,     3,    47,    98,
      48,    -1,   107,    -1,    95,    -1,    44,    79,    46,    -1,
      44,    46,    -1,    44,    54,    93,    46,    -1,    44,    96,
      46,    -1,    44,    96,    54,    93,    46,    -1,    50,    -1,
      97,    -1,    97,    50,    -1,    93,    -1,    97,    50,    93,
      -1,    99,    -1,    99,    54,   100,    -1,    54,   100,    -1,
     100,    -1,    99,    50,   100,    -1,    86,    -1,    86,    92,
      -1,    86,    92,    40,    93,    -1,    71,    86,    -1,    71,
      86,    92,    -1,    71,    86,    92,    40,    93,    -1,    86,
       3,    47,    48,    94,    -1,    86,     3,    47,    98,    48,
      94,    -1,    86,     4,    47,    98,    48,    94,    -1,    56,
       3,    94,    -1,    57,    84,    -1,   103,    49,     3,    -1,
      80,    51,   107,    52,    -1,   103,    51,   107,    52,    -1,
      80,    47,    48,    -1,    80,    47,   105,    48,    -1,   103,
      47,    48,    -1,   103,    47,   105,    48,    -1,    47,   107,
      48,    -1,    70,    -1,   107,    -1,     3,    40,   107,    -1,
     106,    -1,   106,    54,   104,    -1,    54,   104,    -1,   104,
      -1,   106,    50,   104,    -1,    80,    -1,   103,    -1,    72,
      -1,    37,    -1,    72,   107,    -1,    47,    80,    48,   107,
      -1,    47,    80,    88,    48,   107,    -1,    29,   107,    -1,
      31,   107,    -1,    36,   107,    -1,   107,    29,   107,    -1,
     107,    31,   107,    -1,   107,    32,   107,    -1,   107,    33,
     107,    -1,   107,    34,   107,    -1,   107,    35,   107,    -1,
     107,    25,   107,    -1,   107,    26,   107,    -1,   107,    27,
     107,    -1,   107,    28,   107,    -1,   107,    23,   107,    -1,
     107,    24,   107,    -1,   107,    22,   107,    -1,   107,    21,
     107,    -1,   107,    30,   107,    -1,   107,    15,   107,    -1,
      58,    87,    -1,    58,    87,    89,    -1,    58,    87,    89,
      88,    -1,    58,    87,    88,    -1,    58,    87,    88,    95,
      -1,    58,    87,    47,    48,    94,    -1,    58,    87,    88,
      47,    48,    94,    -1,    58,    87,    47,    98,    48,    94,
      -1,    58,    87,    88,    47,    98,    48,    94,    -1,   107,
      39,   107,    41,   107,    -1,   107,    40,   107,    -1,    47,
     107,    50,   107,    48,    -1,    47,   107,    50,   107,    50,
     107,    48,    -1,    47,   107,    50,   107,    50,   107,    50,
     107,    50,   107,    50,   107,    48,    -1,   107,   108,   107,
      -1,   107,   108,    20,    -1,   107,   109,    -1,    15,   107,
      -1,    13,   107,    -1,   107,    15,    -1,   107,     5,   107,
      -1,   107,     6,   107,    -1,   107,     7,   107,    -1,   107,
       8,   107,    -1,   107,     9,   107,    -1,   107,    10,   107,
      -1,    13,    -1,   110,    -1,   109,   110,    -1,   110,   109,
      -1,   109,   110,   109,    -1,    44,    19,   107,    46,    -1,
      44,   107,    46,    -1,    44,   107,    50,   107,    46,    -1,
      11,    -1,    11,   111,    11,    -1,    11,   112,    11,    -1,
      12,    -1,    14,    -1,    17,   107,    -1,    17,   107,    45,
     107,    -1,    17,    18,   107,    -1,    17,    18,   107,    45,
     107,    -1,    16,   107,    -1,    16,   107,    45,   107,    -1,
      53,    -1,    94,    -1,   114,    53,    -1,    59,    47,   107,
      48,   113,    -1,    59,    47,   107,    48,   113,    60,   113,
      -1,    61,    47,   107,    48,   113,    -1,    62,   113,    61,
      47,   107,    48,    53,    -1,    63,    47,   115,    53,   107,
      53,   116,    48,   113,    -1,    64,    53,    -1,    65,    53,
      -1,    66,    53,    -1,    66,   107,    53,    -1,   107,    -1,
      -1,   117,    -1,    85,    -1,    -1,   117,    -1,   114,    -1,
     117,    50,   114,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   162,   162,   166,   167,   172,   173,   183,   184,   185,
     195,   196,   197,   199,   204,   205,   206,   208,   213,   214,
     215,   216,   217,   221,   225,   229,   234,   238,   244,   245,
     249,   250,   255,   256,   261,   262,   267,   268,   269,   271,
     276,   277,   281,   286,   287,   289,   291,   296,   297,   298,
     302,   304,   309,   310,   312,   316,   317,   322,   323,   324,
     326,   328,   330,   335,   337,   339,   344,   345,   350,   351,
     353,   354,   357,   361,   362,   365,   367,   371,   372,   376,
     377,   379,   383,   384,   397,   398,   399,   400,   402,   406,
     410,   412,   414,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   439,   441,   443,   445,   447,   449,   454,   456,   461,
     463,   465,   467,   469,   471,   473,   477,   483,   485,   488,
     490,   491,   493,   494,   495,   496,   503,   504,   506,   509,
     512,   518,   519,   520,   526,   527,   529,   531,   532,   536,
     538,   541,   544,   550,   551,   556,   557,   558,   559,   561,
     563,   565,   567,   569,   570,   571,   572,   576,   580,   581,
     582,   586,   587,   591,   592
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ID", "OP", "ADD", "SUBTRACT", "TIMES",
  "DIVIDE", "MOD", "EXPONENT", "DOTS", "COLONS", "DASHES", "LONGDASH",
  "INCR", "CONTROLS", "TENSION", "ATLEAST", "CURL", "CYCLE", "COR", "CAND",
  "EQ", "NEQ", "LT", "LE", "GT", "GE", "'+'", "CARETS", "'-'", "'*'",
  "'/'", "'%'", "'^'", "LOGNOT", "STRING", "LOOSE", "'?'", "ASSIGN", "':'",
  "DIRTAG", "JOIN_PREC", "'{'", "AND", "'}'", "'('", "')'", "'.'", "','",
  "'['", "']'", "';'", "ELLIPSIS", "IMPORT", "STRUCT", "TYPEDEF", "NEW",
  "IF", "ELSE", "WHILE", "DO", "FOR", "BREAK", "CONTINUE", "RETURN_",
  "STATIC", "PUBLIC_TOK", "PRIVATE_TOK", "THIS", "EXPLICIT", "LIT", "PERM",
  "MODIFIER", "UNARY", "$accept", "file", "fileblock", "bareblock", "name",
  "runnable", "modifiers", "dec", "vardec", "barevardec", "type",
  "celltype", "dims", "dimexps", "decidlist", "decid", "decidstart",
  "varinit", "block", "arrayinit", "basearrayinit", "varinits", "formals",
  "baseformals", "formal", "fundec", "typedec", "value", "argument",
  "arglist", "basearglist", "exp", "join", "dir", "basicjoin", "tension",
  "controls", "stm", "stmexp", "forinit", "forupdate", "stmexplist", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,    43,
     284,    45,    42,    47,    37,    94,   285,   286,   287,    63,
     288,    58,   289,   290,   123,   291,   125,    40,    41,    46,
      44,    91,    93,    59,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    76,    77,    78,    78,    79,    79,    80,    80,    80,
      81,    81,    81,    81,    82,    82,    82,    82,    83,    83,
      83,    83,    83,    84,    85,    86,    86,    87,    88,    88,
      89,    89,    90,    90,    91,    91,    92,    92,    92,    92,
      93,    93,    94,    95,    95,    95,    95,    96,    96,    96,
      97,    97,    98,    98,    98,    99,    99,   100,   100,   100,
     100,   100,   100,   101,   101,   101,   102,   102,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   104,   104,   105,
     105,   105,   106,   106,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   108,   108,   108,   108,
     108,   109,   109,   109,   110,   110,   110,   110,   110,   111,
     111,   111,   111,   112,   112,   113,   113,   113,   113,   113,
     113,   113,   113,   113,   113,   113,   113,   114,   115,   115,
     115,   116,   116,   117,   117
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     0,     2,     0,     2,     1,     3,     3,
       1,     1,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     3,     3,     2,     2,     1,     2,     1,     2,     3,
       3,     4,     1,     3,     1,     3,     1,     2,     3,     4,
       1,     1,     3,     2,     4,     3,     5,     1,     1,     2,
       1,     3,     1,     3,     2,     1,     3,     1,     2,     4,
       2,     3,     5,     5,     6,     6,     3,     2,     3,     4,
       4,     3,     4,     3,     4,     3,     1,     1,     3,     1,
       3,     2,     1,     3,     1,     1,     1,     1,     2,     4,
       5,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     4,     3,     4,     5,     6,     6,     7,     5,
       3,     5,     7,    13,     3,     3,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     1,     1,     2,     2,
       3,     4,     3,     5,     1,     3,     3,     1,     1,     2,
       4,     3,     5,     2,     4,     1,     1,     2,     5,     7,
       5,     7,     9,     2,     2,     2,     3,     1,     0,     1,
       1,     0,     1,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       3,     0,     2,     1,     7,     0,     0,     0,     0,     0,
      87,     5,     0,   155,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    76,    86,    15,    14,    84,
       4,     0,    10,    18,     0,     0,    25,   156,    19,    20,
      85,   167,    11,     0,    84,   128,   127,    91,    92,    93,
       0,     0,    84,     0,     0,     0,     0,     0,    27,    67,
       0,    27,   110,     0,     0,     0,   168,   163,   164,   165,
       0,    88,     0,     0,     0,    26,    17,    16,    12,    13,
      23,    36,     0,    24,    32,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   144,   147,   136,   148,   129,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   126,
     137,   157,     0,     9,    42,     6,     0,     0,    75,     0,
      21,    22,    66,     0,    36,     0,     0,   113,   111,     0,
       0,     0,   170,   173,     0,   169,   166,     7,    71,     0,
      82,     0,    79,    77,     8,    28,     0,     0,     0,    37,
       0,     0,     0,    73,     0,    68,     0,   130,   131,   132,
     133,   134,   135,     0,     0,     0,     0,   109,   107,   106,
     104,   105,   100,   101,   102,   103,    94,   108,    95,    96,
      97,    98,    99,     0,   120,     0,     0,   125,   124,   138,
     139,    89,     0,     0,     0,     0,     0,     0,    57,     0,
      52,    55,     0,     0,     0,   114,     0,   112,     0,     0,
       0,     0,     0,     0,    81,    72,     0,     0,    69,    29,
      38,     0,     0,    33,    35,    41,    40,    74,    70,   153,
       0,   149,   145,   146,     0,     0,   142,     0,   140,    90,
     121,     0,    38,     0,   115,    54,    60,    58,     0,     0,
       0,    30,    43,    47,     0,    50,     0,    48,     0,     0,
       0,   158,   160,     0,     0,   174,    78,    83,    80,    63,
      39,     0,     0,   151,     0,   119,   141,     0,     0,    39,
      61,     0,   117,    56,    53,     0,    45,     0,    49,   116,
       0,    31,     0,     0,   171,    64,    65,   154,     0,   150,
     143,   122,     0,     0,    59,    44,     0,    51,   118,   159,
     161,     0,   172,   152,     0,    62,    46,     0,     0,   162,
       0,     0,     0,   123
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,     2,    51,    44,    30,    31,    32,    33,    34,
     208,    36,    75,   138,    83,    84,    85,   234,    37,   235,
     266,   267,   209,   210,   211,    38,    39,    40,   150,   151,
     152,    41,   118,   119,   120,   175,   176,    42,    43,   144,
     321,   145
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -194
static const short int yypact[] =
{
    -194,    27,   349,  -194,  -194,   661,   661,   661,   661,   661,
     -36,  -194,   661,  -194,    13,    31,    17,    17,    -1,    75,
     413,    83,    21,    80,   505,  -194,   126,  -194,  -194,    26,
    -194,    79,  -194,  -194,    84,    62,  -194,  -194,  -194,  -194,
     -11,  1731,  -194,    86,     0,   105,   105,   105,   105,  -194,
     140,   285,   130,  1032,    93,   101,   111,   -36,     4,  -194,
     153,   112,   -12,   661,   661,    99,   661,  -194,  -194,  -194,
     742,   105,   247,   164,   535,   120,  -194,  -194,  -194,  -194,
    -194,     9,   127,   125,  -194,   142,   485,   183,   661,   661,
     661,   661,   661,   661,   661,    63,  -194,  -194,  -194,   126,
     661,   661,   661,   661,   661,   661,   661,   661,   661,   661,
     661,   661,   661,   661,   661,   661,   661,   565,   595,  -194,
     143,  -194,   661,  -194,  -194,  -194,   661,   -23,  -194,   661,
    -194,  -194,  -194,   136,    67,   122,   535,     1,   144,  1308,
    1352,   147,  -194,  -194,   146,   152,  -194,   167,  -194,   674,
    -194,   166,    14,  1731,  -194,  -194,   840,   171,   135,   120,
     155,   153,   614,  -194,   176,  -194,   888,  1731,  1731,  1731,
    1731,  1731,  1731,   661,   644,   214,   216,   238,  1839,  1864,
    1889,  1889,  1914,  1914,  1914,  1914,   116,  1939,   116,   105,
     105,   105,   105,  1691,  1731,   661,  1078,  -194,   238,   143,
    -194,   105,   661,  1124,   182,   111,     7,    17,   153,   180,
      78,  -194,   936,   455,   197,  -194,   535,   120,   413,   413,
     661,   661,   661,   661,  -194,  -194,   674,   674,  -194,  -194,
     111,   181,   184,  -194,  -194,  -194,  1731,  -194,  -194,  1568,
     661,  1609,  -194,  -194,   661,  1484,  -194,   661,  -194,   105,
    -194,   661,  -194,   189,  -194,  -194,   153,   191,   111,     7,
       7,  -194,  -194,  -194,   614,  -194,   -22,   188,   111,   192,
     984,   194,  -194,  1396,   791,  -194,  1731,  -194,  -194,  -194,
     111,   111,   661,  1650,   661,  1805,  -194,  1526,  1170,  -194,
     201,   614,  -194,  -194,  -194,   198,  -194,   614,   614,  -194,
     111,  -194,   413,   195,   661,  -194,  -194,  1771,   661,  1771,
    -194,  -194,   661,   614,  -194,  -194,   203,  -194,  -194,  -194,
    -194,   204,   152,  1771,  1216,  -194,  -194,   413,   661,  -194,
    1262,   661,  1440,  -194
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -194,  -194,  -194,  -194,     6,   206,  -194,   227,   245,   208,
      10,   246,   -19,  -194,  -194,   103,  -193,  -171,   -25,   148,
    -194,  -194,   -13,  -194,  -189,  -194,  -194,  -194,  -135,   205,
    -194,    -5,  -194,  -109,   161,  -194,  -194,   -15,   -57,  -194,
    -194,   -14
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -28
static const short int yytable[] =
{
      45,    46,    47,    48,    49,    65,    79,    53,    29,   143,
       4,   200,    35,    50,   224,   257,    54,   255,    52,    70,
       4,    71,    58,    61,   296,   202,    60,     3,   157,   -27,
     -27,   132,   297,   127,    56,   135,    86,    58,    87,   136,
      88,    35,   265,   137,    57,   213,    63,    72,   214,    73,
      55,   122,   157,    73,    57,   133,   158,    29,   139,   140,
     133,    35,   159,   290,   226,    81,    82,   153,   227,   156,
     293,   294,    29,    72,    67,    73,    60,    74,   207,   173,
     174,   153,     4,   166,   167,   168,   169,   170,   171,   172,
     248,   277,   278,   295,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   196,   198,   204,   159,    57,   156,   133,   217,
     314,   201,    64,    11,   203,     4,   316,   317,   259,     4,
      66,   212,   260,    68,    14,    15,    16,    80,     4,   121,
     114,    58,   325,   123,   153,   231,   130,   232,   111,   112,
     113,   114,    76,    77,   131,    11,   134,   236,     4,    57,
     141,    73,     9,    10,    58,   275,    58,   154,   239,   241,
     205,   157,    57,    12,   160,   161,   206,    72,   126,    73,
     254,    74,   162,   230,    17,     4,   165,   117,   155,   206,
     245,   253,    57,   207,   220,   216,    25,   249,    26,   221,
       4,   269,   222,   271,   272,   279,   207,   223,   236,   206,
      58,   270,    58,    58,   225,   273,   274,   256,   276,    57,
      58,   153,   153,   229,   237,   242,   207,   243,   258,   280,
     252,   291,   281,   292,    57,   283,   206,   289,   298,   285,
     300,   313,   287,   299,   315,   268,   288,   143,   320,   326,
     147,   206,   327,   207,   302,   305,   306,   125,    78,   236,
       5,    59,     6,    62,   233,    58,    58,   108,   207,   110,
     111,   112,   113,   114,   142,   318,     7,   307,     8,   309,
     199,     0,   117,     9,    10,   215,   236,   319,     4,     0,
     322,   164,   236,   236,    12,   148,     0,     0,     5,     0,
       6,   149,     0,   323,     0,    17,     0,   324,   236,     0,
       0,     0,   329,     0,     7,     0,     8,    25,     0,    26,
       0,     9,    10,   330,     0,     0,   332,     0,     0,    11,
       0,   124,    12,     0,     0,     0,     0,     0,    13,     0,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,     4,     0,     0,    25,     0,    26,    27,    28,
       0,     0,     5,     0,     6,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     7,     0,
       8,     0,     0,     0,     0,     9,    10,     0,     0,     0,
       0,     0,     0,    11,     0,     0,    12,     0,     0,     0,
       0,     0,    13,     0,    14,    15,    16,    17,    18,     0,
      19,    20,    21,    22,    23,    24,     4,     0,     0,    25,
       0,    26,    27,    28,     0,     0,     5,     0,     6,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     7,     0,     8,     0,     0,     0,     0,     9,
      10,     0,     0,     0,     0,     0,     0,    11,     4,     0,
      12,     0,     0,     0,     0,     0,    13,     0,     5,     0,
       6,    17,    18,     0,    19,    20,    21,    22,    23,    24,
       0,     0,     0,    25,     7,    26,     8,     0,   147,     0,
       0,     9,    10,     0,     0,     0,     0,     0,     5,   213,
       6,   262,    12,     0,     0,   263,     0,     0,     4,   264,
       0,     0,     0,    17,     7,     0,     8,     0,     5,     0,
       6,     9,    10,     0,     0,    25,     0,    26,     0,     0,
       0,     0,    12,   163,     7,     0,     8,     0,     4,   149,
       0,     9,    10,    17,     0,     0,     0,     0,     5,     0,
       6,     0,    12,     0,     0,    25,     0,    26,    69,     0,
       0,     0,     0,    17,     7,     0,     8,     0,     4,     0,
       0,     9,    10,     0,     0,    25,     0,    26,     5,     0,
       6,     0,    12,     0,   195,     0,     0,   155,     0,     0,
       0,     0,     0,    17,     7,     0,     8,     0,     4,     0,
       0,     9,    10,     0,     0,    25,     0,    26,     5,     0,
       6,     0,    12,     0,     0,   197,     0,     4,     0,     0,
       0,     0,     0,    17,     7,     0,     8,     5,     0,     6,
       0,     9,    10,     0,     0,    25,     0,    26,     0,     0,
       0,     0,    12,     7,     0,     8,     0,     4,     0,     0,
       9,    10,     0,    17,     0,     0,     0,     5,   213,     6,
       0,    12,   240,     0,     4,    25,     0,    26,     0,     0,
       0,     0,    17,     7,     5,     8,     6,   147,     0,     0,
       9,    10,     0,     0,    25,     0,    26,     5,     0,     6,
       7,    12,     8,     0,     0,     0,     0,     9,    10,     0,
       0,     0,    17,     7,     0,     8,     0,     0,    12,     0,
       9,    10,     0,     0,    25,     0,    26,     0,     0,    17,
       0,    12,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    25,    17,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    25,     0,    26,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,     0,     0,
       0,     0,     0,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,     0,     0,
       0,   115,   116,     0,     0,     0,   117,     0,     0,     0,
       0,     0,     0,     0,     0,   146,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,     0,     0,     0,
       0,     0,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,     0,     0,     0,
     115,   116,     0,     0,     0,   117,     0,     0,     0,     0,
       0,     0,     0,     0,   304,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,     0,     0,     0,     0,
       0,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,     0,     0,     0,   115,
     116,     0,     0,     0,   117,     0,     0,     0,     0,     0,
       0,     0,   228,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,     0,     0,     0,     0,     0,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,   115,   116,     0,
       0,     0,   117,     0,     0,     0,     0,     0,     0,     0,
     238,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,     0,     0,     0,     0,     0,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,     0,     0,     0,   115,   116,     0,     0,     0,
     117,     0,     0,     0,     0,     0,     0,     0,   261,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
       0,     0,     0,     0,     0,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
       0,     0,     0,   115,   116,     0,     0,     0,   117,     0,
       0,     0,     0,     0,     0,     0,   301,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,     0,     0,
       0,     0,     0,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,     0,     0,
       0,   115,   116,     0,     0,     0,   117,     0,     0,     0,
     128,     0,   129,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,     0,     0,     0,     0,     0,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,   115,   116,     0,
       0,     0,   117,     0,   246,     0,     0,     0,   247,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
       0,     0,     0,     0,     0,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
       0,     0,     0,   115,   116,     0,     0,     0,   117,     0,
       0,     0,   250,     0,   251,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,     0,     0,     0,     0,
       0,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,     0,     0,     0,   115,
     116,     0,     0,     0,   117,     0,     0,     0,   311,     0,
     312,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,     0,     0,     0,     0,     0,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,     0,     0,     0,   115,   116,     0,     0,     0,
     117,     0,     0,     0,     0,     0,   328,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,     0,     0,
       0,     0,     0,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,     0,     0,
       0,   115,   116,     0,     0,     0,   117,     0,     0,     0,
       0,     0,   331,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,     0,     0,     0,     0,     0,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,   115,   116,     0,
       0,     0,   117,     0,     0,     0,   218,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,     0,     0,
       0,     0,     0,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,     0,     0,
       0,   115,   116,     0,     0,     0,   117,     0,     0,     0,
     219,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,     0,     0,     0,     0,     0,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,     0,     0,     0,   115,   116,     0,     0,     0,
     117,     0,     0,     0,   303,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,     0,     0,     0,     0,
       0,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,     0,     0,     0,   115,
     116,     0,     0,     0,   117,     0,     0,     0,   333,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
       0,     0,     0,     0,     0,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
       0,     0,     0,   115,   116,     0,     0,     0,   117,     0,
     286,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,     0,     0,     0,     0,     0,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,     0,     0,     0,   115,   116,     0,     0,     0,
     117,     0,   310,    89,    90,    91,    92,    93,    94,     0,
      96,    97,    98,    99,     0,     0,     0,     0,     0,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,   115,   116,     0,
       0,     0,   117,   282,    89,    90,    91,    92,    93,    94,
       0,    96,    97,    98,    99,     0,     0,     0,     0,     0,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,     0,     0,     0,   115,   116,
       0,     0,     0,   117,   284,    89,    90,    91,    92,    93,
      94,     0,    96,    97,    98,    99,     0,     0,     0,     0,
       0,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,     0,     0,     0,   115,
     116,     0,     0,     0,   117,   308,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,     0,     0,     0,
       0,     0,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,     0,     0,     0,
     115,   116,   244,     0,     0,   117,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,     0,     0,     0,
       0,     0,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,     0,     0,     0,
     115,   116,     0,     0,     0,   117,    89,    90,    91,    92,
      93,    94,     0,    96,    97,    98,    99,     0,     0,     0,
       0,     0,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,     0,     0,     0,
     115,   116,     0,     0,     0,   117,    95,    96,    97,    98,
      99,     0,     0,     0,     0,     0,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,     0,     0,     0,   115,     0,     0,     0,     0,   117,
      95,    96,    97,    98,    99,     0,     0,     0,     0,     0,
       0,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,    95,    96,    97,    98,    99,
       0,     0,     0,   117,     0,     0,     0,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
      95,    96,    97,    98,    99,     0,     0,     0,   117,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,    95,    96,    97,    98,    99,
       0,     0,     0,   117,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   108,   109,   110,   111,   112,   113,   114,
      95,    96,    97,    98,    99,     0,     0,     0,   117,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   108,     0,
     110,   111,   112,   113,   114,     0,     0,     0,     0,     0,
       0,     0,     0,   117
};

static const short int yycheck[] =
{
       5,     6,     7,     8,     9,    20,    31,    12,     2,    66,
       3,   120,     2,    49,   149,   208,     3,   206,    12,    24,
       3,    26,    16,    17,    46,    48,    16,     0,    51,     3,
       4,    56,    54,    52,     3,    47,    47,    31,    49,    51,
      51,    31,   213,    62,    37,    44,    47,    47,    47,    49,
      37,    51,    51,    49,    37,    51,    47,    51,    63,    64,
      51,    51,    81,   256,    50,     3,     4,    72,    54,    74,
     259,   260,    66,    47,    53,    49,    66,    51,    71,    16,
      17,    86,     3,    88,    89,    90,    91,    92,    93,    94,
     199,   226,   227,   264,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    47,   134,    37,   122,    51,   138,
     291,   126,    47,    44,   129,     3,   297,   298,    50,     3,
      47,   136,    54,    53,    55,    56,    57,    53,     3,    53,
      35,   135,   313,     3,   149,   158,    53,   160,    32,    33,
      34,    35,    73,    74,    53,    44,     3,   162,     3,    37,
      61,    49,    36,    37,   158,   222,   160,     3,   173,   174,
      48,    51,    37,    47,    47,    50,    54,    47,    48,    49,
     205,    51,    40,    48,    58,     3,     3,    44,    52,    54,
     195,   204,    37,    71,    47,    51,    70,   202,    72,    53,
       3,   214,    50,   218,   219,   230,    71,    40,   213,    54,
     204,   216,   206,   207,    48,   220,   221,   207,   223,    37,
     214,   226,   227,    52,    48,    11,    71,    11,    48,    48,
      48,    40,    48,   258,    37,   240,    54,    48,    50,   244,
      48,    40,   247,   268,    46,    48,   251,   304,    53,    46,
       3,    54,    48,    71,    60,   280,   281,    51,    31,   264,
      13,    16,    15,    17,   161,   259,   260,    29,    71,    31,
      32,    33,    34,    35,    66,   300,    29,   282,    31,   284,
     119,    -1,    44,    36,    37,   137,   291,   302,     3,    -1,
     304,    86,   297,   298,    47,    48,    -1,    -1,    13,    -1,
      15,    54,    -1,   308,    -1,    58,    -1,   312,   313,    -1,
      -1,    -1,   327,    -1,    29,    -1,    31,    70,    -1,    72,
      -1,    36,    37,   328,    -1,    -1,   331,    -1,    -1,    44,
      -1,    46,    47,    -1,    -1,    -1,    -1,    -1,    53,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    66,     3,    -1,    -1,    70,    -1,    72,    73,    74,
      -1,    -1,    13,    -1,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    -1,
      31,    -1,    -1,    -1,    -1,    36,    37,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    -1,    -1,    47,    -1,    -1,    -1,
      -1,    -1,    53,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    66,     3,    -1,    -1,    70,
      -1,    72,    73,    74,    -1,    -1,    13,    -1,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    29,    -1,    31,    -1,    -1,    -1,    -1,    36,
      37,    -1,    -1,    -1,    -1,    -1,    -1,    44,     3,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    53,    -1,    13,    -1,
      15,    58,    59,    -1,    61,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    29,    72,    31,    -1,     3,    -1,
      -1,    36,    37,    -1,    -1,    -1,    -1,    -1,    13,    44,
      15,    46,    47,    -1,    -1,    50,    -1,    -1,     3,    54,
      -1,    -1,    -1,    58,    29,    -1,    31,    -1,    13,    -1,
      15,    36,    37,    -1,    -1,    70,    -1,    72,    -1,    -1,
      -1,    -1,    47,    48,    29,    -1,    31,    -1,     3,    54,
      -1,    36,    37,    58,    -1,    -1,    -1,    -1,    13,    -1,
      15,    -1,    47,    -1,    -1,    70,    -1,    72,    53,    -1,
      -1,    -1,    -1,    58,    29,    -1,    31,    -1,     3,    -1,
      -1,    36,    37,    -1,    -1,    70,    -1,    72,    13,    -1,
      15,    -1,    47,    -1,    19,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    58,    29,    -1,    31,    -1,     3,    -1,
      -1,    36,    37,    -1,    -1,    70,    -1,    72,    13,    -1,
      15,    -1,    47,    -1,    -1,    20,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    58,    29,    -1,    31,    13,    -1,    15,
      -1,    36,    37,    -1,    -1,    70,    -1,    72,    -1,    -1,
      -1,    -1,    47,    29,    -1,    31,    -1,     3,    -1,    -1,
      36,    37,    -1,    58,    -1,    -1,    -1,    13,    44,    15,
      -1,    47,    18,    -1,     3,    70,    -1,    72,    -1,    -1,
      -1,    -1,    58,    29,    13,    31,    15,     3,    -1,    -1,
      36,    37,    -1,    -1,    70,    -1,    72,    13,    -1,    15,
      29,    47,    31,    -1,    -1,    -1,    -1,    36,    37,    -1,
      -1,    -1,    58,    29,    -1,    31,    -1,    -1,    47,    -1,
      36,    37,    -1,    -1,    70,    -1,    72,    -1,    -1,    58,
      -1,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    58,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    72,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    39,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      39,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    53,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    39,
      40,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    52,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    39,    40,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    39,    40,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    39,    40,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    52,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    39,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    39,    40,    -1,
      -1,    -1,    44,    -1,    46,    -1,    -1,    -1,    50,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    39,    40,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    39,
      40,    -1,    -1,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    39,    40,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    50,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    39,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    50,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    39,    40,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    48,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    39,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      48,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    39,    40,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    48,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    39,
      40,    -1,    -1,    -1,    44,    -1,    -1,    -1,    48,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    39,    40,    -1,    -1,    -1,    44,    -1,
      46,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    39,    40,    -1,    -1,    -1,
      44,    -1,    46,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    39,    40,    -1,
      -1,    -1,    44,    45,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    39,    40,
      -1,    -1,    -1,    44,    45,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    39,
      40,    -1,    -1,    -1,    44,    45,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      39,    40,    41,    -1,    -1,    44,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      39,    40,    -1,    -1,    -1,    44,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      39,    40,    -1,    -1,    -1,    44,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    39,    -1,    -1,    -1,    -1,    44,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    44,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    29,    30,    31,    32,    33,    34,    35,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    -1,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    44
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    77,    78,     0,     3,    13,    15,    29,    31,    36,
      37,    44,    47,    53,    55,    56,    57,    58,    59,    61,
      62,    63,    64,    65,    66,    70,    72,    73,    74,    80,
      81,    82,    83,    84,    85,    86,    87,    94,   101,   102,
     103,   107,   113,   114,    80,   107,   107,   107,   107,   107,
      49,    79,    80,   107,     3,    37,     3,    37,    80,    84,
      86,    80,    87,    47,    47,   113,    47,    53,    53,    53,
     107,   107,    47,    49,    51,    88,    73,    74,    83,    94,
      53,     3,     4,    90,    91,    92,    47,    49,    51,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    39,    40,    44,   108,   109,
     110,    53,    51,     3,    46,    81,    48,    88,    48,    50,
      53,    53,    94,    51,     3,    47,    51,    88,    89,   107,
     107,    61,    85,   114,   115,   117,    53,     3,    48,    54,
     104,   105,   106,   107,     3,    52,   107,    51,    47,    88,
      47,    50,    40,    48,   105,     3,   107,   107,   107,   107,
     107,   107,   107,    16,    17,   111,   112,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,    19,   107,    20,   107,   110,
     109,   107,    48,   107,    47,    48,    54,    71,    86,    98,
      99,   100,   107,    44,    47,    95,    51,    88,    48,    48,
      47,    53,    50,    40,   104,    48,    50,    54,    52,    52,
      48,    98,    98,    91,    93,    95,   107,    48,    52,   107,
      18,   107,    11,    11,    41,   107,    46,    50,   109,   107,
      48,    50,    48,    98,    94,   100,    86,    92,    48,    50,
      54,    52,    46,    50,    54,    93,    96,    97,    48,    98,
     107,   113,   113,   107,   107,   114,   107,   104,   104,    94,
      48,    48,    45,   107,    45,   107,    46,   107,   107,    48,
      92,    40,    94,   100,   100,    93,    46,    54,    50,    94,
      48,    52,    60,    48,    53,    94,    94,   107,    45,   107,
      46,    48,    50,    40,    93,    46,    93,    93,    94,   113,
      53,   116,   117,   107,   107,    93,    46,    48,    50,   113,
     107,    50,   107,    48
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 162 "camp.y"
    { absyntax::root = (yyvsp[0].fil); ;}
    break;

  case 3:
#line 166 "camp.y"
    { (yyval.fil) = new file(lexerPos()); ;}
    break;

  case 4:
#line 168 "camp.y"
    { (yyval.fil) = (yyvsp[-1].fil); (yyval.fil)->add((yyvsp[0].run)); ;}
    break;

  case 5:
#line 172 "camp.y"
    { (yyval.bs) = new blockStm(lexerPos()); ;}
    break;

  case 6:
#line 174 "camp.y"
    { (yyval.bs) = (yyvsp[-1].bs); (yyval.bs)->add((yyvsp[0].run)); ;}
    break;

  case 7:
#line 183 "camp.y"
    { (yyval.n) = new simpleName((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 8:
#line 184 "camp.y"
    { (yyval.n) = new qualifiedName((yyvsp[-1].pos), (yyvsp[-2].n), (yyvsp[0].ps).sym); ;}
    break;

  case 9:
#line 185 "camp.y"
    { (yyval.n) = new qualifiedName((yyvsp[-1].pos), new simpleName((yyvsp[-1].pos), (yyvsp[-2].ps).sym),
					    (yyvsp[0].ps).sym); ;}
    break;

  case 10:
#line 195 "camp.y"
    { (yyval.run) = (yyvsp[0].d); ;}
    break;

  case 11:
#line 196 "camp.y"
    { (yyval.run) = (yyvsp[0].s); ;}
    break;

  case 12:
#line 198 "camp.y"
    { (yyval.run) = new modifiedRunnable((yyvsp[-1].ml)->getPos(), (yyvsp[-1].ml), (yyvsp[0].d)); ;}
    break;

  case 13:
#line 200 "camp.y"
    { (yyval.run) = new modifiedRunnable((yyvsp[-1].ml)->getPos(), (yyvsp[-1].ml), (yyvsp[0].bs)); ;}
    break;

  case 14:
#line 204 "camp.y"
    { (yyval.ml) = new modifierList((yyvsp[0].mod).pos); (yyval.ml)->add((yyvsp[0].mod).val); ;}
    break;

  case 15:
#line 205 "camp.y"
    { (yyval.ml) = new modifierList((yyvsp[0].perm).pos); (yyval.ml)->add((yyvsp[0].perm).val); ;}
    break;

  case 16:
#line 207 "camp.y"
    { (yyval.ml) = (yyvsp[-1].ml); (yyval.ml)->add((yyvsp[0].mod).val); ;}
    break;

  case 17:
#line 209 "camp.y"
    { (yyval.ml) = (yyvsp[-1].ml); (yyval.ml)->add((yyvsp[0].perm).val); ;}
    break;

  case 18:
#line 213 "camp.y"
    { (yyval.d) = (yyvsp[0].vd); ;}
    break;

  case 19:
#line 214 "camp.y"
    { (yyval.d) = (yyvsp[0].d); ;}
    break;

  case 20:
#line 215 "camp.y"
    { (yyval.d) = (yyvsp[0].d); ;}
    break;

  case 21:
#line 216 "camp.y"
    { (yyval.d) = new importdec((yyvsp[-2].pos), (yyvsp[-1].ps).sym); ;}
    break;

  case 22:
#line 217 "camp.y"
    { (yyval.d) = new importdec((yyvsp[-2].pos), (yyvsp[-1].ps).sym); ;}
    break;

  case 23:
#line 221 "camp.y"
    { (yyval.vd) = (yyvsp[-1].vd); ;}
    break;

  case 24:
#line 225 "camp.y"
    { (yyval.vd) = new vardec((yyvsp[-1].t)->getPos(), (yyvsp[-1].t), (yyvsp[0].dil)); ;}
    break;

  case 25:
#line 229 "camp.y"
    { (yyval.t) = (yyvsp[0].t); ;}
    break;

  case 26:
#line 234 "camp.y"
    { (yyval.t) = new arrayTy((yyvsp[-1].n), (yyvsp[0].dim)); ;}
    break;

  case 27:
#line 238 "camp.y"
    { (yyval.t) = new nameTy((yyvsp[0].n)); ;}
    break;

  case 28:
#line 244 "camp.y"
    { (yyval.dim) = new dimensions((yyvsp[-1].pos)); ;}
    break;

  case 29:
#line 245 "camp.y"
    { (yyval.dim) = (yyvsp[-2].dim); (yyval.dim)->increase(); ;}
    break;

  case 30:
#line 249 "camp.y"
    { (yyval.elist) = new explist((yyvsp[-2].pos)); (yyval.elist)->add((yyvsp[-1].e)); ;}
    break;

  case 31:
#line 251 "camp.y"
    { (yyval.elist) = (yyvsp[-3].elist); (yyval.elist)->add((yyvsp[-1].e)); ;}
    break;

  case 32:
#line 255 "camp.y"
    { (yyval.dil) = new decidlist((yyvsp[0].di)->getPos()); (yyval.dil)->add((yyvsp[0].di)); ;}
    break;

  case 33:
#line 257 "camp.y"
    { (yyval.dil) = (yyvsp[-2].dil); (yyval.dil)->add((yyvsp[0].di)); ;}
    break;

  case 34:
#line 261 "camp.y"
    { (yyval.di) = new decid((yyvsp[0].dis)->getPos(), (yyvsp[0].dis)); ;}
    break;

  case 35:
#line 263 "camp.y"
    { (yyval.di) = new decid((yyvsp[-2].dis)->getPos(), (yyvsp[-2].dis), (yyvsp[0].vi)); ;}
    break;

  case 36:
#line 267 "camp.y"
    { (yyval.dis) = new decidstart((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 37:
#line 268 "camp.y"
    { (yyval.dis) = new decidstart((yyvsp[-1].ps).pos, (yyvsp[-1].ps).sym, (yyvsp[0].dim)); ;}
    break;

  case 38:
#line 269 "camp.y"
    { (yyval.dis) = new fundecidstart((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym, 0,
                                            new formals((yyvsp[-1].pos))); ;}
    break;

  case 39:
#line 272 "camp.y"
    { (yyval.dis) = new fundecidstart((yyvsp[-3].ps).pos, (yyvsp[-3].ps).sym, 0, (yyvsp[-1].fls)); ;}
    break;

  case 40:
#line 276 "camp.y"
    { (yyval.vi) = (yyvsp[0].e); ;}
    break;

  case 41:
#line 277 "camp.y"
    { (yyval.vi) = (yyvsp[0].ai); ;}
    break;

  case 42:
#line 282 "camp.y"
    { (yyval.bs) = (yyvsp[-1].bs); ;}
    break;

  case 43:
#line 286 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[-1].pos)); ;}
    break;

  case 44:
#line 288 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[-3].pos)); (yyval.ai)->addRest((yyvsp[-1].vi)); ;}
    break;

  case 45:
#line 290 "camp.y"
    { (yyval.ai) = (yyvsp[-1].ai); ;}
    break;

  case 46:
#line 292 "camp.y"
    { (yyval.ai) = (yyvsp[-3].ai); (yyval.ai)->addRest((yyvsp[-1].vi)); ;}
    break;

  case 47:
#line 296 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[0].pos)); ;}
    break;

  case 48:
#line 297 "camp.y"
    { (yyval.ai) = (yyvsp[0].ai); ;}
    break;

  case 49:
#line 298 "camp.y"
    { (yyval.ai) = (yyvsp[-1].ai); ;}
    break;

  case 50:
#line 302 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[0].vi)->getPos());
		     (yyval.ai)->add((yyvsp[0].vi));;}
    break;

  case 51:
#line 305 "camp.y"
    { (yyval.ai) = (yyvsp[-2].ai); (yyval.ai)->add((yyvsp[0].vi)); ;}
    break;

  case 52:
#line 309 "camp.y"
    { (yyval.fls) = (yyvsp[0].fls); ;}
    break;

  case 53:
#line 311 "camp.y"
    { (yyval.fls) = (yyvsp[-2].fls); (yyval.fls)->addRest((yyvsp[0].fl)); ;}
    break;

  case 54:
#line 312 "camp.y"
    { (yyval.fls) = new formals((yyvsp[-1].pos)); (yyval.fls)->addRest((yyvsp[0].fl)); ;}
    break;

  case 55:
#line 316 "camp.y"
    { (yyval.fls) = new formals((yyvsp[0].fl)->getPos()); (yyval.fls)->add((yyvsp[0].fl)); ;}
    break;

  case 56:
#line 318 "camp.y"
    { (yyval.fls) = (yyvsp[-2].fls); (yyval.fls)->add((yyvsp[0].fl)); ;}
    break;

  case 57:
#line 322 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].t)->getPos(), (yyvsp[0].t)); ;}
    break;

  case 58:
#line 323 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].dis)->getPos(), (yyvsp[-1].t), (yyvsp[0].dis)); ;}
    break;

  case 59:
#line 325 "camp.y"
    { (yyval.fl) = new formal((yyvsp[-2].dis)->getPos(), (yyvsp[-3].t), (yyvsp[-2].dis), (yyvsp[0].vi)); ;}
    break;

  case 60:
#line 327 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].t)->getPos(), (yyvsp[0].t), 0, 0, true); ;}
    break;

  case 61:
#line 329 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].dis)->getPos(), (yyvsp[-1].t), (yyvsp[0].dis), 0, true); ;}
    break;

  case 62:
#line 331 "camp.y"
    { (yyval.fl) = new formal((yyvsp[-2].dis)->getPos(), (yyvsp[-3].t), (yyvsp[-2].dis), (yyvsp[0].vi), true); ;}
    break;

  case 63:
#line 336 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-2].pos), (yyvsp[-4].t), (yyvsp[-3].ps).sym, new formals((yyvsp[-2].pos)), (yyvsp[0].bs)); ;}
    break;

  case 64:
#line 338 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-3].pos), (yyvsp[-5].t), (yyvsp[-4].ps).sym, (yyvsp[-2].fls), (yyvsp[0].bs)); ;}
    break;

  case 65:
#line 340 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-3].pos), (yyvsp[-5].t), (yyvsp[-4].ps).sym, (yyvsp[-2].fls), (yyvsp[0].bs)); ;}
    break;

  case 66:
#line 344 "camp.y"
    { (yyval.d) = new recorddec((yyvsp[-2].pos), (yyvsp[-1].ps).sym, (yyvsp[0].bs)); ;}
    break;

  case 67:
#line 345 "camp.y"
    { (yyval.d) = new typedec((yyvsp[-1].pos), (yyvsp[0].vd)); ;}
    break;

  case 68:
#line 350 "camp.y"
    { (yyval.e) = new fieldExp((yyvsp[-1].pos), (yyvsp[-2].e), (yyvsp[0].ps).sym); ;}
    break;

  case 69:
#line 351 "camp.y"
    { (yyval.e) = new subscriptExp((yyvsp[-2].pos),
                              new nameExp((yyvsp[-3].n)->getPos(), (yyvsp[-3].n)), (yyvsp[-1].e)); ;}
    break;

  case 70:
#line 353 "camp.y"
    { (yyval.e) = new subscriptExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 71:
#line 354 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-1].pos),
                                      new nameExp((yyvsp[-2].n)->getPos(), (yyvsp[-2].n)),
                                      new arglist()); ;}
    break;

  case 72:
#line 358 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-2].pos), 
                                      new nameExp((yyvsp[-3].n)->getPos(), (yyvsp[-3].n)),
                                      (yyvsp[-1].alist)); ;}
    break;

  case 73:
#line 361 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-1].pos), (yyvsp[-2].e), new arglist()); ;}
    break;

  case 74:
#line 363 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].alist)); ;}
    break;

  case 75:
#line 366 "camp.y"
    { (yyval.e) = (yyvsp[-1].e); ;}
    break;

  case 76:
#line 367 "camp.y"
    { (yyval.e) = new thisExp((yyvsp[0].pos)); ;}
    break;

  case 77:
#line 371 "camp.y"
    { (yyval.arg).name=0;      (yyval.arg).val=(yyvsp[0].e); ;}
    break;

  case 78:
#line 372 "camp.y"
    { (yyval.arg).name=(yyvsp[-2].ps).sym; (yyval.arg).val=(yyvsp[0].e); ;}
    break;

  case 79:
#line 376 "camp.y"
    { (yyval.alist) = (yyvsp[0].alist); ;}
    break;

  case 80:
#line 378 "camp.y"
    { (yyval.alist) = (yyvsp[-2].alist); (yyval.alist)->rest = (yyvsp[0].arg); ;}
    break;

  case 81:
#line 379 "camp.y"
    { (yyval.alist) = new arglist(); (yyval.alist)->rest = (yyvsp[0].arg); ;}
    break;

  case 82:
#line 383 "camp.y"
    { (yyval.alist) = new arglist(); (yyval.alist)->add((yyvsp[0].arg)); ;}
    break;

  case 83:
#line 385 "camp.y"
    { (yyval.alist) = (yyvsp[-2].alist); (yyval.alist)->add((yyvsp[0].arg)); ;}
    break;

  case 84:
#line 397 "camp.y"
    { (yyval.e) = new nameExp((yyvsp[0].n)->getPos(), (yyvsp[0].n)); ;}
    break;

  case 85:
#line 398 "camp.y"
    { (yyval.e) = (yyvsp[0].e); ;}
    break;

  case 86:
#line 399 "camp.y"
    { (yyval.e) = (yyvsp[0].e); ;}
    break;

  case 87:
#line 400 "camp.y"
    { (yyval.e) = new stringExp((yyvsp[0].ps).pos, *(yyvsp[0].ps).sym); ;}
    break;

  case 88:
#line 402 "camp.y"
    { (yyval.e) = new scaleExp((yyvsp[-1].e)->getPos(), (yyvsp[-1].e), (yyvsp[0].e)); ;}
    break;

  case 89:
#line 407 "camp.y"
    { (yyval.e) = new castExp((yyvsp[-2].n)->getPos(), new nameTy((yyvsp[-2].n)), (yyvsp[0].e)); ;}
    break;

  case 90:
#line 411 "camp.y"
    { (yyval.e) = new castExp((yyvsp[-3].n)->getPos(), new arrayTy((yyvsp[-3].n), (yyvsp[-2].dim)), (yyvsp[0].e)); ;}
    break;

  case 91:
#line 413 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 92:
#line 415 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 93:
#line 416 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 94:
#line 417 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 95:
#line 418 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 96:
#line 419 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 97:
#line 420 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 98:
#line 421 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 99:
#line 422 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 100:
#line 423 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 101:
#line 424 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 102:
#line 425 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 103:
#line 426 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 104:
#line 427 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 105:
#line 428 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 106:
#line 429 "camp.y"
    { (yyval.e) = new andExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 107:
#line 430 "camp.y"
    { (yyval.e) = new orExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 108:
#line 431 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 109:
#line 432 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 110:
#line 434 "camp.y"
    { (yyval.e) = new newRecordExp((yyvsp[-1].pos), (yyvsp[0].t)); ;}
    break;

  case 111:
#line 440 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-2].pos), (yyvsp[-1].t), (yyvsp[0].elist), 0, 0); ;}
    break;

  case 112:
#line 442 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-3].pos), (yyvsp[-2].t), (yyvsp[-1].elist), (yyvsp[0].dim), 0); ;}
    break;

  case 113:
#line 444 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-2].pos), (yyvsp[-1].t), 0, (yyvsp[0].dim), 0); ;}
    break;

  case 114:
#line 446 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-3].pos), (yyvsp[-2].t), 0, (yyvsp[-1].dim), (yyvsp[0].ai)); ;}
    break;

  case 115:
#line 448 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-4].pos), (yyvsp[-3].t), new formals((yyvsp[-2].pos)), (yyvsp[0].bs)); ;}
    break;

  case 116:
#line 450 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-5].pos),
                                             new arrayTy((yyvsp[-4].t)->getPos(), (yyvsp[-4].t), (yyvsp[-3].dim)),
                                             new formals((yyvsp[-2].pos)),
                                             (yyvsp[0].bs)); ;}
    break;

  case 117:
#line 455 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-5].pos), (yyvsp[-4].t), (yyvsp[-2].fls), (yyvsp[0].bs)); ;}
    break;

  case 118:
#line 457 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-6].pos),
                                             new arrayTy((yyvsp[-5].t)->getPos(), (yyvsp[-5].t), (yyvsp[-4].dim)),
                                             (yyvsp[-2].fls),
                                             (yyvsp[0].bs)); ;}
    break;

  case 119:
#line 462 "camp.y"
    { (yyval.e) = new conditionalExp((yyvsp[-3].pos), (yyvsp[-4].e), (yyvsp[-2].e), (yyvsp[0].e)); ;}
    break;

  case 120:
#line 463 "camp.y"
    { (yyval.e) = new assignExp((yyvsp[-1].pos), (yyvsp[-2].e), (yyvsp[0].e)); ;}
    break;

  case 121:
#line 466 "camp.y"
    { (yyval.e) = new pairExp((yyvsp[-4].pos), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 122:
#line 468 "camp.y"
    { (yyval.e) = new tripleExp((yyvsp[-6].pos), (yyvsp[-5].e), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 123:
#line 470 "camp.y"
    { (yyval.e) = new transformExp((yyvsp[-12].pos), (yyvsp[-11].e), (yyvsp[-9].e), (yyvsp[-7].e), (yyvsp[-5].e), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 124:
#line 472 "camp.y"
    { (yyvsp[-1].j)->pushFront((yyvsp[-2].e)); (yyvsp[-1].j)->pushBack((yyvsp[0].e)); (yyval.e) = (yyvsp[-1].j); ;}
    break;

  case 125:
#line 474 "camp.y"
    { (yyvsp[-1].j)->pushFront((yyvsp[-2].e));
                     (yyvsp[-1].j)->pushBack(new nullaryExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym));
                     (yyval.e) = (yyvsp[-1].j) ;}
    break;

  case 126:
#line 478 "camp.y"
    { (yyvsp[0].se)->setSide(camp::OUT);
                     joinExp *jexp =
                         new joinExp((yyvsp[0].se)->getPos(), symbol::trans(".."));
                     (yyval.e)=jexp;
                     jexp->pushBack((yyvsp[-1].e)); jexp->pushBack((yyvsp[0].se)); ;}
    break;

  case 127:
#line 484 "camp.y"
    { (yyval.e) = new prefixExp((yyvsp[-1].ps).pos, (yyvsp[0].e), symbol::trans("+")); ;}
    break;

  case 128:
#line 486 "camp.y"
    { (yyval.e) = new prefixExp((yyvsp[-1].ps).pos, (yyvsp[0].e), symbol::trans("-")); ;}
    break;

  case 129:
#line 489 "camp.y"
    { (yyval.e) = new postfixExp((yyvsp[0].ps).pos, (yyvsp[-1].e), symbol::trans("+")); ;}
    break;

  case 130:
#line 490 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 131:
#line 492 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 132:
#line 493 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 133:
#line 494 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 134:
#line 495 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 135:
#line 497 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 136:
#line 503 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos,(yyvsp[0].ps).sym); ;}
    break;

  case 137:
#line 505 "camp.y"
    { (yyval.j) = (yyvsp[0].j); ;}
    break;

  case 138:
#line 507 "camp.y"
    { (yyvsp[-1].se)->setSide(camp::OUT);
                     (yyval.j) = (yyvsp[0].j); (yyval.j)->pushFront((yyvsp[-1].se)); ;}
    break;

  case 139:
#line 510 "camp.y"
    { (yyvsp[0].se)->setSide(camp::IN);
                     (yyval.j) = (yyvsp[-1].j); (yyval.j)->pushBack((yyvsp[0].se)); ;}
    break;

  case 140:
#line 513 "camp.y"
    { (yyvsp[-2].se)->setSide(camp::OUT); (yyvsp[0].se)->setSide(camp::IN);
                     (yyval.j) = (yyvsp[-1].j); (yyval.j)->pushFront((yyvsp[-2].se)); (yyval.j)->pushBack((yyvsp[0].se)); ;}
    break;

  case 141:
#line 518 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym, (yyvsp[-1].e)); ;}
    break;

  case 142:
#line 519 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-2].pos), symbol::opTrans("spec"), (yyvsp[-1].e)); ;}
    break;

  case 143:
#line 521 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-4].pos), symbol::opTrans("spec"),
                                          new pairExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].e))); ;}
    break;

  case 144:
#line 526 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 145:
#line 528 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym); (yyval.j)->pushBack((yyvsp[-1].e)); ;}
    break;

  case 146:
#line 530 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym); (yyval.j)->pushBack((yyvsp[-1].e)); ;}
    break;

  case 147:
#line 531 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 148:
#line 532 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 149:
#line 536 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym,
                              new booleanExp((yyvsp[-1].ps).pos, false)); ;}
    break;

  case 150:
#line 539 "camp.y"
    { (yyval.e) = new ternaryExp((yyvsp[-3].ps).pos, (yyvsp[-2].e), (yyvsp[-3].ps).sym, (yyvsp[0].e),
                              new booleanExp((yyvsp[-3].ps).pos, false)); ;}
    break;

  case 151:
#line 542 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-2].ps).pos, (yyvsp[0].e), (yyvsp[-2].ps).sym,
                              new booleanExp((yyvsp[-1].ps).pos, true)); ;}
    break;

  case 152:
#line 545 "camp.y"
    { (yyval.e) = new ternaryExp((yyvsp[-4].ps).pos, (yyvsp[-2].e), (yyvsp[-4].ps).sym, (yyvsp[0].e),
                              new booleanExp((yyvsp[-3].ps).pos, true)); ;}
    break;

  case 153:
#line 550 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 154:
#line 552 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-3].ps).pos, (yyvsp[-2].e), (yyvsp[-3].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 155:
#line 556 "camp.y"
    { (yyval.s) = new emptyStm((yyvsp[0].pos)); ;}
    break;

  case 156:
#line 557 "camp.y"
    { (yyval.s) = (yyvsp[0].bs); ;}
    break;

  case 157:
#line 558 "camp.y"
    { (yyval.s) = (yyvsp[-1].s); ;}
    break;

  case 158:
#line 560 "camp.y"
    { (yyval.s) = new ifStm((yyvsp[-4].pos), (yyvsp[-2].e), (yyvsp[0].s)); ;}
    break;

  case 159:
#line 562 "camp.y"
    { (yyval.s) = new ifStm((yyvsp[-6].pos), (yyvsp[-4].e), (yyvsp[-2].s), (yyvsp[0].s)); ;}
    break;

  case 160:
#line 564 "camp.y"
    { (yyval.s) = new whileStm((yyvsp[-4].pos), (yyvsp[-2].e), (yyvsp[0].s)); ;}
    break;

  case 161:
#line 566 "camp.y"
    { (yyval.s) = new doStm((yyvsp[-6].pos), (yyvsp[-5].s), (yyvsp[-2].e)); ;}
    break;

  case 162:
#line 568 "camp.y"
    { (yyval.s) = new forStm((yyvsp[-8].pos), (yyvsp[-6].run), (yyvsp[-4].e), (yyvsp[-2].sel), (yyvsp[0].s)); ;}
    break;

  case 163:
#line 569 "camp.y"
    { (yyval.s) = new breakStm((yyvsp[-1].pos)); ;}
    break;

  case 164:
#line 570 "camp.y"
    { (yyval.s) = new continueStm((yyvsp[-1].pos)); ;}
    break;

  case 165:
#line 571 "camp.y"
    { (yyval.s) = new returnStm((yyvsp[-1].pos)); ;}
    break;

  case 166:
#line 572 "camp.y"
    { (yyval.s) = new returnStm((yyvsp[-2].pos), (yyvsp[-1].e)); ;}
    break;

  case 167:
#line 576 "camp.y"
    { (yyval.s) = new expStm((yyvsp[0].e)->getPos(), (yyvsp[0].e)); ;}
    break;

  case 168:
#line 580 "camp.y"
    { (yyval.run) = 0; ;}
    break;

  case 169:
#line 581 "camp.y"
    { (yyval.run) = (yyvsp[0].sel); ;}
    break;

  case 170:
#line 582 "camp.y"
    { (yyval.run) = (yyvsp[0].vd); ;}
    break;

  case 171:
#line 586 "camp.y"
    { (yyval.sel) = 0; ;}
    break;

  case 172:
#line 587 "camp.y"
    { (yyval.sel) = (yyvsp[0].sel); ;}
    break;

  case 173:
#line 591 "camp.y"
    { (yyval.sel) = new stmExpList((yyvsp[0].s)->getPos()); (yyval.sel)->add((yyvsp[0].s)); ;}
    break;

  case 174:
#line 593 "camp.y"
    { (yyval.sel) = (yyvsp[-2].sel); (yyval.sel)->add((yyvsp[0].s)); ;}
    break;


    }

/* Line 1037 of yacc.c.  */
#line 2737 "camp.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



