/***** Autogenerated from runtime.in *****/
/*****
 * runtime.in
 * Tom Prince 2005/4/15
 *
 * Generate runtime functions.
 *
 *****/

#include "angle.h"
#include "pair.h"
#include "triple.h"
#include "transform.h"
#include "path.h"
#include "pen.h"
#include "guide.h"
#include "picture.h"
#include "drawpath.h"
#include "drawfill.h"
#include "drawclipbegin.h"
#include "drawclipend.h"
#include "drawlabel.h"
#include "drawverbatim.h"
#include "drawgsave.h"
#include "drawgrestore.h"
#include "drawlayer.h"
#include "drawimage.h"
#include "drawgroup.h"
#include "fileio.h"
#include "genv.h"
#include "builtin.h"
#include "texfile.h"
#include "pipestream.h"
#include "parser.h"
#include "stack.h"
  
using namespace vm;
using namespace camp;
using namespace settings;

namespace run {
using camp::pair;
using mem::string;
}
namespace trans {
using namespace types;
}



namespace run {

void gen0__label(vm::stack *gen_theStack)
{
  pen * p = vm::pop<pen *>(gen_theStack);
  pair a = vm::pop<pair>(gen_theStack);
  pair z = vm::pop<pair>(gen_theStack);
  double r = vm::pop<double>(gen_theStack);
  string * t = vm::pop<string *>(gen_theStack);
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawLabel(*t,r,z,a,p));
}

void gen1_basealign(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);

  { gen_theStack->push<pen*>(new pen(n >= 0 && n < nBaseLine 
                   ? (BaseLine) n
                   : DEFBASE)); return; }
}

void gen2_draw(vm::stack *gen_theStack)
{
  pen * n = vm::pop<pen *>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawPath(p,*n));
}

void gen3_endclip(vm::stack *gen_theStack)
{
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawClipEnd(false));
}

void gen4_gsave(vm::stack *gen_theStack)
{
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawGsave());
}

void gen5_grestore(vm::stack *gen_theStack)
{
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawGrestore());
}

void gen6_begingroup(vm::stack *gen_theStack)
{
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawBegin());
}

void gen7_endgroup(vm::stack *gen_theStack)
{
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawEnd());
}

void gen8_add(vm::stack *gen_theStack)
{
  picture * from = vm::pop<picture *>(gen_theStack);
  picture * to = vm::pop<picture *>(gen_theStack);

  to->add(*from);
}

void gen9_prepend(vm::stack *gen_theStack)
{
  picture * from = vm::pop<picture *>(gen_theStack);
  picture * to = vm::pop<picture *>(gen_theStack);

  to->prepend(*from);
}

void gen10_fileprefix(vm::stack *gen_theStack)
{

  { gen_theStack->push<string>(outname); return; }
}

// Interactive mode
void gen11_interact(vm::stack *gen_theStack)
{
  bool interaction = vm::pop<bool>(gen_theStack);

  if(interact::interactive) settings::suppressStandard=!interaction;
}

void gen12_interact(vm::stack *gen_theStack)
{

  { gen_theStack->push<bool>(interact::interactive && !settings::suppressStandard); return; }
}

// System commands
void gen13_system(vm::stack *gen_theStack)
{
  string * str = vm::pop<string *>(gen_theStack);

  if(settings::suppressStandard) { gen_theStack->push<int>(0); return; }
  
  if(safe) error("system() call disabled; override with option -unsafe");
  else { gen_theStack->push<int>(System(str->c_str())); return; }
}

void gen14_abort(vm::stack *gen_theStack)
{
  string * msg = vm::pop<string *>(gen_theStack);

  error(msg->c_str());
}

// Path operations
void gen15_point(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.point(n)); return; }
}

void gen16_point(vm::stack *gen_theStack)
{
  double t = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.point(t)); return; }
}

void gen17_precontrol(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.precontrol(n)); return; }
}

void gen18_precontrol(vm::stack *gen_theStack)
{
  double t = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.precontrol(t)); return; }
}

void gen19_postcontrol(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.postcontrol(n)); return; }
}

void gen20_postcontrol(vm::stack *gen_theStack)
{
  double t = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.postcontrol(t)); return; }
}

void gen21_dir(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(unit(p.direction(n))); return; }
}

void gen22_dir(vm::stack *gen_theStack)
{
  double t = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(unit(p.direction(t))); return; }
}

void gen23_reverse(vm::stack *gen_theStack)
{
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<path>(p.reverse()); return; }
}

void gen24_subpath(vm::stack *gen_theStack)
{
  int e = vm::pop<int>(gen_theStack);
  int b = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<path>(p.subpath(b,e)); return; }
}

void gen25_subpath(vm::stack *gen_theStack)
{
  double e = vm::pop<double>(gen_theStack);
  double b = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<path>(p.subpath(b,e)); return; }
}

void gen26_length(vm::stack *gen_theStack)
{
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<int>(p.length()); return; }
}

void gen27_cyclic(vm::stack *gen_theStack)
{
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<bool>(p.cyclic()); return; }
}

void gen28_straight(vm::stack *gen_theStack)
{
  int i = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<bool>(p.straight(i)); return; }
}

void gen29_arclength(vm::stack *gen_theStack)
{
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<double>(p.arclength()); return; }
}

void gen30_arctime(vm::stack *gen_theStack)
{
  double dval = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<double>(p.arctime(dval)); return; }
}

void gen31_dirtime(vm::stack *gen_theStack)
{
  pair z = vm::pop<pair>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<double>(p.directiontime(z)); return; }
}

void gen32_intersect(vm::stack *gen_theStack)
{
  path y = vm::pop<path>(gen_theStack);
  path x = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(intersectiontime(x,y)); return; }
}

void gen33_cubiclength(vm::stack *gen_theStack)
{
  double goal = vm::pop<double>(gen_theStack);
  triple z1 = vm::pop<triple>(gen_theStack);
  triple z1m = vm::pop<triple>(gen_theStack);
  triple z0p = vm::pop<triple>(gen_theStack);
  triple z0 = vm::pop<triple>(gen_theStack);

  { gen_theStack->push<double>(cubiclength(z0,z0p,z1m,z1,goal)); return; }
}

void gen34_length(vm::stack *gen_theStack)
{
  string * s = vm::pop<string *>(gen_theStack);

  { gen_theStack->push<int>((int) s->length()); return; }
}

void gen35_find(vm::stack *gen_theStack)
{
  int pos = vm::pop<int>(gen_theStack);
  string * sub = vm::pop<string *>(gen_theStack);
  string * s = vm::pop<string *>(gen_theStack);

  { gen_theStack->push<int>((int) s->find(*sub,pos)); return; }
}

void gen36_rfind(vm::stack *gen_theStack)
{
  int pos = vm::pop<int>(gen_theStack);
  string * sub = vm::pop<string *>(gen_theStack);
  string * s = vm::pop<string *>(gen_theStack);

  { gen_theStack->push<int>((int) s->rfind(*sub,pos)); return; }
}

void gen37_reverse(vm::stack *gen_theStack)
{
  string s = vm::pop<string>(gen_theStack);

  reverse(s.begin(),s.end());
  { gen_theStack->push<string>(s); return; }
}

void gen38_insert(vm::stack *gen_theStack)
{
  string * sub = vm::pop<string *>(gen_theStack);
  int pos = vm::pop<int>(gen_theStack);
  string s = vm::pop<string>(gen_theStack);

  if ((size_t)pos < s.length())
    { gen_theStack->push<string>(s.insert(pos,*sub)); return; }
  { gen_theStack->push<string>(s); return; }
}

void gen39_substr(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  int pos = vm::pop<int>(gen_theStack);
  string* s = vm::pop<string*>(gen_theStack);

  if ((size_t)pos < s->length())
    { gen_theStack->push<string>(s->substr(pos,n)); return; }
  { gen_theStack->push<string>(""); return; } // TODO: Make this shared again.
}

void gen40_erase(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  int pos = vm::pop<int>(gen_theStack);
  string s = vm::pop<string>(gen_theStack);

  if ((size_t)pos < s.length())
    { gen_theStack->push<string>(s.erase(pos,n)); return; }
  { gen_theStack->push<string>(s); return; } 
}

} // namespace run

namespace trans {

void gen_base_venv(venv &ve)
{
  addFunc(ve, run::gen0__label, primVoid(), "_label", primPicture(), primString(), primReal(), primPair(), primPair(), primPen());
  addFunc(ve, run::gen1_basealign, primPen(), "basealign", primInt());
  addFunc(ve, run::gen2_draw, primVoid(), "draw", primPicture(), primPath(), primPen());
  addFunc(ve, run::gen3_endclip, primVoid(), "endclip", primPicture());
  addFunc(ve, run::gen4_gsave, primVoid(), "gsave", primPicture());
  addFunc(ve, run::gen5_grestore, primVoid(), "grestore", primPicture());
  addFunc(ve, run::gen6_begingroup, primVoid(), "begingroup", primPicture());
  addFunc(ve, run::gen7_endgroup, primVoid(), "endgroup", primPicture());
  addFunc(ve, run::gen8_add, primVoid(), "add", primPicture(), primPicture());
  addFunc(ve, run::gen9_prepend, primVoid(), "prepend", primPicture(), primPicture());
  addFunc(ve, run::gen10_fileprefix, primString() , "fileprefix");
  addFunc(ve, run::gen11_interact, primVoid(), "interact", primBoolean());
  addFunc(ve, run::gen12_interact, primBoolean(), "interact");
  addFunc(ve, run::gen13_system, primInt(), "system", primString());
  addFunc(ve, run::gen14_abort, primVoid(), "abort", primString());
  addFunc(ve, run::gen15_point, primPair(), "point", primPath(), primInt());
  addFunc(ve, run::gen16_point, primPair(), "point", primPath(), primReal());
  addFunc(ve, run::gen17_precontrol, primPair(), "precontrol", primPath(), primInt());
  addFunc(ve, run::gen18_precontrol, primPair(), "precontrol", primPath(), primReal());
  addFunc(ve, run::gen19_postcontrol, primPair(), "postcontrol", primPath(), primInt());
  addFunc(ve, run::gen20_postcontrol, primPair(), "postcontrol", primPath(), primReal());
  addFunc(ve, run::gen21_dir, primPair(), "dir", primPath(), primInt());
  addFunc(ve, run::gen22_dir, primPair(), "dir", primPath(), primReal());
  addFunc(ve, run::gen23_reverse, primPath(), "reverse", primPath());
  addFunc(ve, run::gen24_subpath, primPath(), "subpath", primPath(), primInt(), primInt());
  addFunc(ve, run::gen25_subpath, primPath(), "subpath", primPath(), primReal(), primReal());
  addFunc(ve, run::gen26_length, primInt(), "length", primPath());
  addFunc(ve, run::gen27_cyclic, primBoolean(), "cyclic", primPath());
  addFunc(ve, run::gen28_straight, primBoolean(), "straight", primPath(), primInt());
  addFunc(ve, run::gen29_arclength, primReal(), "arclength", primPath());
  addFunc(ve, run::gen30_arctime, primReal(), "arctime", primPath(), primReal());
  addFunc(ve, run::gen31_dirtime, primReal(), "dirtime", primPath(), primPair());
  addFunc(ve, run::gen32_intersect, primPair(), "intersect", primPath(), primPath());
  addFunc(ve, run::gen33_cubiclength, primReal(), "cubiclength", primTriple(), primTriple(), primTriple(), primTriple(), primReal());
  addFunc(ve, run::gen34_length, primInt(), "length", primString());
  addFunc(ve, run::gen35_find, primInt(), "find", primString(), primString(), primInt());
  addFunc(ve, run::gen36_rfind, primInt(), "rfind", primString(), primString(), primInt());
  addFunc(ve, run::gen37_reverse, primString() , "reverse", primString() );
  addFunc(ve, run::gen38_insert, primString() , "insert", primString() , primInt(), primString());
  addFunc(ve, run::gen39_substr, primString() , "substr", primString(), primInt(), primInt());
  addFunc(ve, run::gen40_erase, primString() , "erase", primString() , primInt(), primInt());
}

} // namesapce trans
